'From Squeak3.1alpha of 7 March 2001 [latest update: #4173] on 1 August 2001 at 1:25:21 am'!

!Object methodsFor: 'morphic wrappers' stamp: 'fg 7/31/2001 02:03'!
wrappedClass
	^ self class! !


!HandMorph methodsFor: '-- all --' stamp: 'fg 7/31/2001 12:05'!
attachMorph: m
	"Position the center of the given morph under this hand, then grab it.
	This method is used to grab far away or newly created morphs."
	| delta |
	m isMorph ifFalse: [^ self].
	m isWorldOrHandMorph ifTrue: [^ self].
	self releaseMouseFocus. "Break focus"
	delta _ m bounds extent // 8.
	m position: (self position - delta).
	m formerPosition: m position.
	targetOffset _ m position - self position.
	self addMorphBack: m.! !


!ScrollPane methodsFor: 'access' stamp: 'fg 8/1/2001 00:56'!
highlightedIndex
	scroller submorphs withIndexDo: [:any :i | any highlightedForMouseDown ifTrue: [^ i]].
	^ 0! !


!PluggableListMorph methodsFor: 'initialization' stamp: 'fg 7/30/2001 20:46'!
initialize
	super initialize.
	self enableDragNDrop! !

!PluggableListMorph methodsFor: 'drag and drop' stamp: 'fg 7/31/2001 02:46'!
startDrag: evt
	| ddm itemMorph itemModel index |
	self dragEnabled 
		ifTrue:
			[index _ self highlightedIndex.
			index > 0 
				ifTrue: 
					[itemMorph _ scroller submorphs at: index.
					itemModel _ self model getItemAt: index fromListNamed: getListSelector]].
	(itemMorph isNil or: [evt hand hasSubmorphs]) ifTrue: [^self].
	itemMorph highlightForMouseDown: false.
	model okToChange 
		ifFalse: 
			[Cursor normal show.
			^ self  "No change if model is locked" ].

	"itemMorph ~= self selection ifTrue: [self setSelectedMorph: itemMorph]."
	ddm _ TransferMorph withPassenger: (self model dragPassengerFor: itemModel inMorph: self) from: self.
	ddm dragTransferType: (self model dragTransferTypeForMorph: self).
	Preferences dragNDropWithAnimation
			ifTrue: [self model dragAnimationFor: itemMorph transferMorph: ddm].
	evt hand grabMorph: ddm.
	evt hand releaseMouseFocus: self.! !


!SimpleHierarchicalListMorph methodsFor: 'initialization' stamp: 'fg 8/1/2001 00:49'!
initialize
	super initialize.
	self on: #mouseMove send: #mouseStillDown:onItem: to: self.
	self enableDragNDrop! !

!SimpleHierarchicalListMorph methodsFor: 'dropping/grabbing' stamp: 'fg 8/1/2001 01:12'!
startDrag: evt
	| ddm itemMorph itemModel index |
	self dragEnabled 
		ifTrue:
			[index _ self highlightedIndex.
			index > 0 
				ifTrue: 
					[itemMorph _ scroller submorphs at: index.
					itemModel _ itemMorph complexContents item]].
	(itemMorph isNil or:[evt hand hasSubmorphs]) ifTrue: [^self].
	itemMorph highlightForMouseDown: false.
	itemMorph ~= self selectedMorph ifTrue: [self setSelectedMorph: itemMorph].
	ddm _ TransferMorph withPassenger: (self model dragPassengerFor: itemModel inMorph: self) from: self.
	ddm dragTransferType: (self model dragTransferTypeForMorph: self).
	Preferences dragNDropWithAnimation
			ifTrue: [self model dragAnimationFor: itemMorph transferMorph: ddm].
	evt hand grabMorph: ddm.
	evt hand releaseMouseFocus: self.! !


!StringHolder methodsFor: 'drag and drop' stamp: 'fg 7/31/2001 03:11'!
dragTransferTypeForMorph: dragSource 
	^(dragSource isKindOf: PluggableListMorph)
		ifTrue: [dragSource getListSelector]! !

!StringHolder methodsFor: 'drag and drop' stamp: 'fg 7/31/2001 03:11'!
getItemAt: anInteger fromListNamed: aSymbol 
	self subclassResponsibility
! !


!Browser methodsFor: 'drag and drop' stamp: 'fg 7/30/2001 21:17'!
acceptDroppingMorph: transferMorph event: evt inMorph: dstListMorph 
	"Here we are fetching informations from the dropped transferMorph and 
	             performing the correct action for this drop."

	| srcType success srcBrowser |
	success _ false.
	srcType _ transferMorph dragTransferType.
	srcBrowser _ transferMorph source model.
	srcType == #messageList ifTrue: [success _ self
					acceptMethod: transferMorph passenger methodSelector
					messageCategory: srcBrowser selectedMessageCategoryName
					class: transferMorph passenger methodClass
					atListMorph: dstListMorph
					internal: self == srcBrowser
					copy: transferMorph shouldCopy].
	srcType == #classList
		ifTrue: 
			[success _ self
				changeCategoryForClass: transferMorph passenger
				srcSystemCategory: srcBrowser selectedSystemCategoryName
				atListMorph: dstListMorph
				internal: self == srcBrowser
				copy: transferMorph shouldCopy].
	^success!
]style[(67 637 4 223)f1b,f1,f1cblue;b,f1! !

!Browser methodsFor: 'drag and drop' stamp: 'fg 7/31/2001 16:43'!
getItemAt: anInteger fromListNamed: aSymbol 
	aSymbol == #classList 
		ifTrue: [^ Smalltalk at: ((self classList at: anInteger) withBlanksTrimmed asSymbol)].
	aSymbol == #messageCategoryList 
		ifTrue: [^ self messageCategoryList at: anInteger].
	aSymbol == #messageList
		ifTrue: [^ MethodModel class: self selectedClassOrMetaClass selector: (self messageList at: anInteger)].
	aSymbol == #systemCategoryList
		ifTrue: [^ self systemCategoryList at: anInteger].
	aSymbol == #systemCategorySingleton
		ifTrue: [^ self systemCategorySingleton at: anInteger].
	self error: 'You should program the ', aSymbol printString, ' case.'
! !

!Browser methodsFor: 'drag and drop' stamp: 'fg 7/16/2001 13:40'!
systemCategoryListDrag: item
	^ item contents! !

!Browser methodsFor: 'initialize-release' stamp: 'ar 1/31/2001 20:55'!
openAsMorphEditing: editString
	"Create a pluggable version of all the morphs for a Browser in Morphic"
	| window hSepFrac |

	hSepFrac _ 0.4.
	window _ (SystemWindow labelled: 'later') model: self.

	window 
		addMorph: self buildMorphicSystemCatList
		frame: (0@0 corner: 0.25@hSepFrac).
	self 
		addClassAndSwitchesTo: window 
		at: (0.25@0 corner: 0.5@hSepFrac)
		plus: 0.
	window 
		addMorph: self buildMorphicMessageCatList
		frame: (0.5@0 extent: 0.25@hSepFrac).
	window addMorph: self buildMorphicMessageList
		frame: (0.75@0 extent: 0.25@hSepFrac).
	self 
		addLowerPanesTo: window 
		at: (0@hSepFrac corner: 1@1) 
		with: editString.
	window setUpdatablePanesFrom: #(systemCategoryList classList messageCategoryList messageList).
	^ window! !

!Browser methodsFor: 'initialize-release' stamp: 'sw 1/24/2001 21:24'!
openEditString: aString
        "Create a pluggable version of all the views for a Browser, including views and controllers."
        | systemCategoryListView classListView 
        messageCategoryListView messageListView browserCodeView topView switchView underPane y optionalButtonsView annotationPane |

        self couldOpenInMorphic ifTrue: [^ self openAsMorphEditing: aString].
        "Sensor leftShiftDown ifTrue: [^ self openAsMorphEditing: aString].
                uncomment-out for testing morphic browser embedded in mvc project"

        topView _ StandardSystemView new model: self.
        topView borderWidth: 1. "label and minSize taken care of by caller"

        systemCategoryListView _ PluggableListView on: self
                list: #systemCategoryList
                selected: #systemCategoryListIndex
                changeSelected: #systemCategoryListIndex:
                menu: #systemCategoryMenu:
                keystroke: #systemCatListKey:from:.
        systemCategoryListView window: (0 @ 0 extent: 50 @ 70).
        topView addSubView: systemCategoryListView.

        classListView _ PluggableListView on: self
                list: #classList
                selected: #classListIndex
                changeSelected: #classListIndex:
                menu: #classListMenu:shifted:
                keystroke: #classListKey:from:.
        classListView window: (0 @ 0 extent: 50 @ 62).
        topView addSubView: classListView toRightOf: systemCategoryListView.

        switchView _ self buildInstanceClassSwitchView.
        switchView borderWidth: 1.
        topView addSubView: switchView below: classListView.

        messageCategoryListView _ PluggableListView on: self
                list: #messageCategoryList
                selected: #messageCategoryListIndex
                changeSelected: #messageCategoryListIndex:
                menu: #messageCategoryMenu:.
        messageCategoryListView window: (0 @ 0 extent: 50 @ 70).
        topView addSubView: messageCategoryListView toRightOf: classListView.

        messageListView _ PluggableListView on: self
                list: #messageList
                selected: #messageListIndex
                changeSelected: #messageListIndex:
                menu: #messageListMenu:shifted:
                keystroke: #messageListKey:from:.
        messageListView window: (0 @ 0 extent: 50 @ 70).
        messageListView menuTitleSelector: #messageListSelectorTitle.
        topView addSubView: messageListView toRightOf: messageCategoryListView.

       self wantsAnnotationPane
                ifTrue:
                        [annotationPane _ PluggableTextView on: self
                                text: #annotation accept: nil
                                readSelection: nil menu: nil.
                        annotationPane window: (0@0 extent: 200@self optionalAnnotationHeight).
                        topView addSubView: annotationPane below: systemCategoryListView.
                        underPane _ annotationPane.
                        y _ 110 - self optionalAnnotationHeight]
                ifFalse: [
                        underPane _ systemCategoryListView.
                        y _ 110].

        self wantsOptionalButtons ifTrue:
                [optionalButtonsView _ self buildOptionalButtonsView.
                optionalButtonsView borderWidth: 1.
                topView addSubView: optionalButtonsView below: underPane.
                underPane _ optionalButtonsView.
                y _ y - self optionalButtonHeight].

        browserCodeView _ PluggableTextView on: self 
                        text: #contents accept: #contents:notifying:
                        readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
        browserCodeView window: (0@0 extent: 200@y).
        topView addSubView: browserCodeView below: underPane.
        aString ifNotNil: [browserCodeView editString: aString.
                        browserCodeView hasUnacceptedEdits: true].
        topView setUpdatablePanesFrom: #(systemCategoryList classList messageCategoryList messageList).

        ^ topView! !


!ChangeSorter methodsFor: 'drag and drop' stamp: 'fg 7/31/2001 01:24'!
classAt: anInteger
	| className tokens |
	className _ self classList at: anInteger.
	tokens _ className findTokens: Character separators.
	^ Smalltalk at: tokens first asSymbol! !

!ChangeSorter methodsFor: 'drag and drop' stamp: 'fg 8/1/2001 01:03'!
getItemAt: anInteger fromListNamed: aSymbol 
	aSymbol == #classList 
		ifTrue: [^ self classAt: anInteger].
	aSymbol == #changeSetList 
		ifTrue: [^ ChangeSorter changeSetNamed: (self changeSetList at: anInteger)].
	aSymbol == #messageList
		ifTrue: [^ MethodModel class: self selectedClassOrMetaClass selector: (self messageList at: anInteger)].

	self error: 'You should program the #', aSymbol, ' case.'
! !


!Debugger methodsFor: 'drag and drop' stamp: 'fg 7/31/2001 03:05'!
getItemAt: anInteger fromListNamed: aSymbol 
	| who | 
	aSymbol == #contextStackList 
		ifTrue: 
			[who _ (contextStack at: anInteger) method who.
			^ MethodModel class: who first selector: who second].

	self error: 'You should program the ', aSymbol, ' case.'
! !


!FileList methodsFor: 'drag and drop' stamp: 'fg 7/31/2001 17:43'!
getItemAt: anInteger fromListNamed: aSymbol 
	aSymbol == #fileList 
		ifTrue: [^ self fileList at: anInteger].

	aSymbol == #volumeList 
		ifTrue: [^ (self volumeList at: anInteger) withBlanksTrimmed].
	self error: 'You should program the #', aSymbol, ' case.'! !


!Inspector methodsFor: 'drag & drop' stamp: 'fg 7/31/2001 03:19'!
getItemAt: anInteger fromListNamed: aSymbol 
	aSymbol == #fieldList 
		ifTrue: [^ self selection].

	self error: 'You should program the ', aSymbol, ' case.'! !


!MessageSet methodsFor: 'drag and drop' stamp: 'fg 7/31/2001 03:05'!
getItemAt: anInteger fromListNamed: aSymbol 
	aSymbol == #messageList
		ifTrue: 
			[^ MethodModel 
				class: (self messageList at: anInteger) actualClass
				selector: (self messageList at: anInteger) methodSymbol].

	self error: 'You should program the ', aSymbol, ' case.'
! !


!MethodModel methodsFor: 'morphic wrappers' stamp: 'fg 7/31/2001 02:05'!
wrappedClass
	^ methodClass isMeta 
		ifTrue: [methodClass soleInstance] 
		ifFalse: [methodClass]
! !

!MethodModel methodsFor: 'printing' stamp: 'fg 7/30/2001 20:13'!
printOn: aStream
	aStream 
		print: methodClass;
		nextPutAll: ' | ';
		print: methodSelector! !


!MethodModel class methodsFor: 'instance creation' stamp: 'fg 7/30/2001 20:13'!
class: aClass selector: aSymbol
	^ self new class: aClass selector: aSymbol! !


!TestModel methodsFor: 'drag and drop' stamp: 'fg 7/31/2001 12:35'!
getItemAt: anInteger fromListNamed: aSymbol

	aSymbol == #errorList 
		ifTrue: [^ self result errors at: anInteger].

	aSymbol == #failureList 
		ifTrue: [^ self result failures at: anInteger].
	
	self error: 'You should program the #', aSymbol, ' case.'! !


!TransferMorph methodsFor: 'testing' stamp: 'fg 7/30/2001 20:30'!
shiftPressed
	^ self shouldCopy! !

!TransferMorph methodsFor: 'dropping/grabbing' stamp: 'fg 7/31/2001 01:44'!
justDroppedInto: targetMorph event: anEvent 
	"If only world wants this TransferMorph, treat it as unaccepted (see also >>delete)."

	super justDroppedInto: targetMorph event: anEvent.
	accepted _ targetMorph ~= self world.
	accepted 
		ifTrue: 
			[self animationForMoveSuccess: accepted.
			self dropNotifyRecipient 
				ifNotNil: [self dropNotifyRecipient dropAcceptedMorph: self from: targetMorph]]
		ifFalse: 
			[self result wrapAndAttachTo: anEvent hand].
	self delete! !

!TransferMorph methodsFor: 'dropping/grabbing' stamp: 'fg 7/31/2001 02:04'!
result
	^ self shiftPressed
		ifTrue: [passenger wrappedClass]
		ifFalse: [passenger]! !


!VersionsBrowser methodsFor: 'drag and drop' stamp: 'fg 7/31/2001 03:26'!
getItemAt: anInteger fromListNamed: aSymbol 
	aSymbol == #list 
		ifTrue: [^ self changeList at: anInteger].

	self error: 'You should program the ', aSymbol, ' case.'! !


!TransferMorph reorganize!
('testing' shiftPressed shouldCopy)
('private' animationForMoveSuccess: initDraggedMorph privateFullMoveBy:)
('accessing' copy dragTransferType dragTransferType: draggedMorph draggedMorph: dropNotifyRecipient dropNotifyRecipient: move passenger passenger: source source:)
('initialization' initialize)
('dropping/grabbing' aboutToBeGrabbedBy: justDroppedInto:event: result result: result:from: undoGrabCommand)
('submorphs-add/remove' delete)
!

Inspector removeSelector: #dragPassengerFor:inMorph:!

!FileList reorganize!
('initialization' directory: labelString modelSleep modelWakeUp optionalButtonHeight optionalButtonRow optionalButtonSpecs optionalButtonView release setFileStream:)
('volume list and pattern' askServerInfo deleteDirectory fileNameFormattedFrom:sizePad: listForPattern: pattern pattern: removeServer veryDeepFixupWith: volumeList volumeListIndex volumeListIndex: volumeMenu:)
('file list' fileList fileListIndex fileListIndex:)
('file list menu' addFileToZip addNew:byEvaluating: addNewDirectory addNewFile browseChanges compressFile copyName deleteFile editFile fileAllIn fileContentsMenu:shifted: fileInSelection fileIntoNewChangeSet fileListMenu: fileNameSuffix fileSelectedMenu: fullFileListMenu:shifted: get getHex importImage itemsForAnyFile itemsForFileEnding: itemsForNoFile loadCRDictionary loadCRDisplayProperties noFileSelectedMenu: offerAllFileOptions open3DSFile openArchiveViewer openAsBackground openAsFlash openAsMovie openAsTTF openBookFromFile openImageInWindow openInBrowser openMorphFromFile openProjectFromFile openTapeFromFile openVRMLFile perform:orSendTo: playMidiFile putUpdate removeLinefeeds renameFile renderFile saveGZipContents sortByDate sortByName sortBySize spawn: templateFile viewGZipContents)
('private' addPath: contents defaultContents entriesMatching: errorMustBeMorph fileNameFromFormattedItem: folderString fullName getSuffix: put: readContentsBrief: readContentsHex: readServerBrief recentDirs resort: sortBlock sortingByDate sortingByName sortingBySize uncompressedFileName updateFileList)
('menu messages' browseFile browseFiles)
('drag and drop' getItemAt:fromListNamed:)
!

Browser removeSelector: #dragPassengerFor:inMorph:!
