'From Squeak3.1alpha of 7 March 2001 [latest update: #4173] on 31 July 2001 at 9:01:53 pm'!

!CarryingMorph class methodsFor: 'instance creation' stamp: 'fg 7/10/2001 20:06'!
carryAndAttach: passengerMorph to: targetMorph 
	| answer |
	Preferences carryingActivated
		ifTrue: [answer _ self new passenger: passengerMorph;
						 target: targetMorph;
						 attach: true.
			targetMorph world addMorph: answer.
			answer startStepping.
			^ answer]. 
	targetMorph attachMorph: passengerMorph! !


!ClassMorphicWrapper methodsFor: 'delegation' stamp: 'fg 7/14/2001 20:54'!
editCodeFor: aClass selector: aSymbol event: evt
	(MethodModel class: aClass selector: aSymbol) openAsMorph.
	self updateContents

! !


!CodeHolder methodsFor: 'annotation' stamp: 'fg 7/31/2001 20:23'!
annotationForSelector: aSelector ofClass: aClass
	"Provide a line of content for an annotation pane, representing information about the given selector and class"

	| stamp  sendersCount implementorsCount aCategory separator aString aList  aComment aStream requestList |

	aStream _ ReadWriteStream on: ''.
	requestList _ self annotationRequests.
	 
	separator _ requestList size > 1
		ifTrue:
			[self annotationSeparator]
		ifFalse:
			[''].
	requestList do:
		[:aRequest |
		aRequest == #firstComment ifTrue:
			[aComment _ aClass firstCommentAt: aSelector.
			aComment isEmptyOrNil ifFalse:
				[aStream nextPutAll: aComment, separator]].

		aRequest == #documentation ifTrue:
			[aComment _ aClass precodeCommentOrInheritedCommentFor:   aSelector.
			aComment isEmptyOrNil ifFalse:
				[aStream nextPutAll: aComment, separator]].

		aRequest == #timeStamp ifTrue:
			[stamp _ self timeStamp.
			aStream nextPutAll: (stamp size > 0
				ifTrue: [stamp, separator]
				ifFalse: ['no timeStamp', separator])].

		aRequest == #messageCategory ifTrue:
			[aCategory _ aClass organization categoryOfElement: aSelector.
			aCategory ifNotNil: "woud be nil for a method no longer present, e.g. in a recent-submissions browser"
				[aStream nextPutAll: aCategory, separator]].

		aRequest == #sendersCount ifTrue:
			[sendersCount _ (Smalltalk allCallsOn: aSelector) size.
			sendersCount _ sendersCount == 1
				ifTrue:
					['1 sender']
				ifFalse:
					[sendersCount printString, ' senders'].
			aStream nextPutAll: sendersCount, separator].

		aRequest == #implementorsCount ifTrue:
			[implementorsCount _ Smalltalk numberOfImplementorsOf: aSelector.
			implementorsCount _ implementorsCount == 1
				ifTrue:
					['1 implementor']
				ifFalse:
					[implementorsCount printString, ' implementors'].
			aStream nextPutAll: implementorsCount,  separator].

		aRequest == #priorVersionsCount ifTrue:
			[self addPriorVersionsCountForSelector: aSelector ofClass: aClass to: aStream].

		aRequest == #priorTimeStamp ifTrue:
			[stamp _ VersionsBrowser timeStampFor: aSelector class: aClass reverseOrdinal: 2.
			stamp ifNotNil: [aStream nextPutAll: 'prior time stamp: ', stamp, separator]].

		aRequest == #recentChangeSet ifTrue:
			[aString _ ChangeSorter mostRecentChangeSetWithChangeForClass: aClass selector: aSelector.
			aString size > 0 ifTrue: [aStream nextPutAll: aString, separator]].

		aRequest == #allChangeSets ifTrue:
			[aList _ ChangeSorter allChangeSetsWithClass: aClass selector: aSelector.
			aList size > 0
				ifTrue:
					["aList size = 1
						ifTrue:
							[aStream nextPutAll: 'only in change set ']
						ifFalse:
							[aStream nextPutAll: 'in change sets: ']."
					aList do:
						[:aChangeSet | aStream nextPutAll: aChangeSet name, ' ']]
				ifFalse:
					[aStream nextPutAll: 'in no change set'].
			aStream nextPutAll: separator]].
		
	^ aStream contents! !


!MethodModel methodsFor: 'code pane menu' stamp: 'fg 7/31/2001 20:41'!
addModelItemsToWindowMenu: aMenu
	^ self buildMenuInto: aMenu! !

!MethodModel methodsFor: 'code pane menu' stamp: 'fg 7/31/2001 20:34'!
addModelMenuItemsTo: aMenu forMorph: aMorph hand: aHandMorph 
	^ self buildMenuInto: aMenu
	! !

!MethodModel methodsFor: 'code pane menu' stamp: 'fg 7/31/2001 20:58'!
buildMenuInto: aMenu
	| submenu sendersMenu implementorsMenu |
	aMenu addLine.
	aMenu add: 'class' target: self action: #openClass.
	sendersMenu _ MenuMorph new
				add: 'senders'
				target: self
				selector: #senders;
			
				add: 'local senders'
				target: self
				selector: #localSenders;
			
				add: 'project senders'
				target: self
				selector: #projectSenders;
			 yourself.
	implementorsMenu _ MenuMorph new
				add: 'implementors'
				target: self
				selector: #implementors;
			
				add: 'local implementors'
				target: self
				selector: #localImplementors;
			
				add: 'project implementors'
				target: self
				selector: #projectImplementors;
			 yourself.
	submenu _ MenuMorph new
		add: 'new category... ' target: self selector: #addCategory;
		addLine.
	self
		addMenuForClass: self classField superclass
		toMenu: submenu
		isSuperOf: self classField.
	submenu addLine.
	self
		addMenuForClass: self classField
		toMenu: submenu
		isSuperOf: nil.
"
	instVarMenu _ MenuMorph new.
	self classField allInstVarNames do: [:n | instVarMenu
			add: n
			target: self classField
			selector: #browseAllAccessesTo:
			argument: n].
	classVarMenu _ MenuMorph new.
	self classField theNonMetaClass allClassVarNames do: [:n | classVarMenu
			add: n
			target: self classField theNonMetaClass
			selector: #browseClassVarRefsTo:
			argument: n].
"
	aMenu
		addLine; add: 'senders' subMenu: sendersMenu;
		add: 'implementors' subMenu: implementorsMenu;
		addLine;
		add: 'versions' target: self selector: #browseVersions;
		addLine;
		add: 'remove selector' target: self selector: #remove;
		add: 'category' subMenu: submenu;
		addLine;
		add: 'inst var references' target: self classField selector: #browseInstVarRefs;
		add: 'class var references' target: self classField theNonMetaClass selector: #browseClassVarRefs;
		addLine;
		add: 'inspect parse tree' target: self selector: #parseTree.
	^ aMenu! !

!MethodModel methodsFor: 'opening' stamp: 'fg 7/16/2001 10:07'!
buildMethodMathMorph
	| codePane frame |
	codePane _ MethodMathMorph
				on: self
				text: #contents
				accept: #contents:notifying:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:.
	codePane borderWidth: 1;
	 color: Color white;
	 scrollBarOnLeft: true;
	 extent: 400 @ 130;
	 activate;
	 retractable: false;
	 name: 'methodPane';
	 yourself.
	frame _ MethodFrameMorph new addMorphBack: codePane.
	frame activate.
	^ frame! !

!MethodModel methodsFor: 'opening' stamp: 'fg 7/14/2001 21:05'!
initialExtent
	"Answer the desired extent for the receiver when it is first opened on the screen.  "

	^ 450@185! !

!MethodModel methodsFor: 'opening' stamp: 'fg 7/14/2001 20:42'!
openAsMorph
	^ Preferences methodsInsideSystemWindows
		ifTrue: [self openSystemWindowMorph]
		ifFalse: [self openMethodMathMorph]
! !

!MethodModel methodsFor: 'opening' stamp: 'fg 7/31/2001 21:01'!
openClass
	| class |
	class _ self selectedClass.
	class isMeta ifTrue: [class _ class soleInstance].
	class wrapAndAttachTo: World activeHand! !

!MethodModel methodsFor: 'opening' stamp: 'fg 7/16/2001 10:08'!
openMethodMathMorph
	World primaryHand attachMorph: self buildMethodMathMorph
! !

!MethodModel methodsFor: 'opening' stamp: 'fg 7/14/2001 21:07'!
openSystemWindowMorph
	| window text aTextMorph bottom |
	text _ PluggableTextMorph
		on: self
		text: #contents
		accept: #contents:notifying:
		readSelection: #contentsSelection
		menu: #codePaneMenu:shifted:.
	(window _ SystemWindow labelled: self labelString) 
		model: self.

	self wantsAnnotationPane
		ifTrue:
			[aTextMorph _ PluggableTextMorph on: self
					text: #annotation accept: nil
					readSelection: nil menu: nil.
			aTextMorph askBeforeDiscardingEdits: false.
			window addMorph: aTextMorph
				frame: (0@0.85 corner: 1@1).
			bottom _ 0.85]
		ifFalse:
			[bottom _ 1].

	^ window
		addMorph: text frame: (0@0 corner: 1@bottom);
		extent: self initialExtent;
		openInWorld
	
! !


!Preferences class methodsFor: 'initialization' stamp: 'fg 7/10/2001 20:11'!
addMorphicWrappersPreferences
	" 
	Preferences addMorphicWrappersPreferences 
	"
	|  categoryName | 
	categoryName _ #MW.
	self 
		addPreference: #methodsInsideSystemWindows
		category: categoryName
		default: true
		balloonHelp: 'If true, methods are shown inside window, otherwise are shown with a special morhp (MethodMathMorph)'.

	self 
		addPreference: #carryingActivated
		category: categoryName
		default: false
		balloonHelp: 'If true, new morphic wrappers are carried with an invisible morph when they enter the world. Otherwise they just instantly stick to the hand'.
! !

"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."

Preferences addMorphicWrappersPreferences !

